{
 ASMetr Component 1.1 Copyright  1997
       Andrey Abakumov (aga@oficina.rnd.su)

The ASMetr this Scale of measurement of a
type "speedmetr".

Properties:
 Position    - current position on the switch;
 Sliding     - scale 
 Max         - maximum value (up to 270)
               (Min - allways zero);
 PrintValues - to print or not print values
}
unit ASMetr;

interface

uses
  SysUtils,Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,ASFunc;

type
  TASMetr = class(TGraphicControl)
  private
    { Private declarations }
    FPosition:Integer;
    FMax:Integer;
    FSliding:Integer;
    FPrintValues:Boolean;

    Procedure SetPosition(Value:Integer);
    Procedure SetMax(Value:Integer);
    Procedure SetSliding(Value:Integer);
    Procedure SetPrintValues(Value:Boolean);
    
  protected
    { Protected declarations }
   Procedure DrawFace;virtual;
   Procedure DrawTicks;virtual;
   Procedure DrawPointer;virtual;

   Procedure Paint;override;
  public
    { Public declarations }
   Constructor Create(AOwner:TComponent);override;
  published
    { Published declarations }
    property Position:Integer
             read FPosition
             write SetPosition
             default 1;

    property Max:Integer
             read FMax
             write SetMax
             default 10;

    property Sliding:Integer
             read FSliding
             write SetSliding
             default 1;

    property PrintValues:Boolean
             read FPrintValues
             write SetPrintValues
             default False;
  end;
Var
   sA,eA:TPoint;
   PositionOld,
   PositionNatur:Integer;
   Dest:TRect;

procedure Register;

implementation
Constructor TASMetr.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
 FMax:=10;
 FSliding:=1;
 FPosition:=0;
 Width:=150;
 Height:=150;
 Offset:={60}5;
 Offset2:=Round(Offset+15);
 Offset4:=Round(Offset+10);
 FPrintValues:=False;
end;

Procedure TASMetr.DrawFace;
begin
 With Canvas Do
  begin
  Pen.Color:=$00909090;
  Brush.Color:=$00909090;
  Brush.Style:=bsSolid;
  Pen.Width:=2;

  GradValues(TickCount);
  StartA:=270+Trunc(p2 / 2);
  EndA:=270-Trunc(p2 / 2);

  GradToCoords({310}StartA,StartA+30{340},sA,eA);
  Brush.Color:=clRed;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  GradToCoords(StartA+30{340},StartA+80{45},sA,eA);
  Brush.Color:=clMaroon;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  GradToCoords(StartA+80{45},EndA{230},sA,eA);
  Brush.Color:=clGreen;
  Pie(Offset,Offset,Width-Offset,Height-Offset,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);

  Pen.Color:=Color;
  Brush.Color:=Color;
  Ellipse(Offset2,Offset2,Width-Offset2,Height-Offset2);

  Pen.Color:=clWhite;
  Pen.Width:=2;
  GradToCoords(StartA,EndA,sA,eA);
  Arc(Offset2,Offset2,Width-Offset2,Height-Offset2,
      midX+sA.X,midY-sA.Y,midX+eA.X,midY-eA.Y);
  end;
end;

Procedure TASMetr.DrawTicks;
var
   tmpStartA:Integer;
   i,j:Integer;
begin
With Canvas Do
 begin
 Brush.Color:=clBlack;
 GradValues(TickCount);
 iGrad:=Trunc(t1);
 StartA:=270+Trunc(p2 / 2);
 EndA:=270-Trunc(p2 / 2);

 GradToCoords(StartA,EndA,sA,eA);

 Brush.Style:=bsSolid;
 Pen.Color := clBlack;
 Brush.Color:=Color;
 Pen.Width:=1;

 tmpStartA:=StartA;

 For j:=1 To TickCount+1 Do
  begin
  GradToCoords(StartA,EndA,sA,eA);

  ValuesTicks(StartA,Offset2+10);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(StartA,Offset2);
  LineTo(CoordPointX,CoordPointY);

  If FPrintValues Then
   begin
   wText:=TextWidth(IntToStr((FSliding*FMax)-(j-1)*FSliding));
   hText:=TextHeight(IntToStr((FSliding*FMax)-(j-1)*FSliding));
   ValuesTicks(StartA,Offset2+Round(hText*2.5));
   TextValuesForTicks(spInside);

   TextOut(CoordPointX,CoordPointY,
          IntToStr((FSliding*FMax)-(j-1)*FSliding));
   end;
  ValuesTicks(StartA,Offset2+10);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(StartA,Offset2);
  LineTo(CoordPointX,CoordPointY);
  Inc(StartA,iGrad);
  end;
end;
{
 With Canvas Do
  begin
  Pen.Color:=clWhite;
  Pen.Width:=2;
  StartA:=tmpStartA;
  GradToCoords(StartA,EndA,sA,eA);
  Arc(Offset2,Offset2,Width-Offset2,Height-Offset2,
       midX+sA.X,midY-sA.Y,
       midX+eA.X,midY-eA.Y);
  Pen.Width:=1;
  Brush.Color:=Self.Color;
  Pen.Color:=Self.Color;

 { Ellipse(Offset2+10,Offset2+10,
          Width-Offset2-10,Height-Offset2-10);
  end;}
end;

Procedure TASMetr.DrawPointer;
var
   tW,tH,
   tX,tY:Integer;
   An:Integer;
begin
With Canvas Do
 begin
 Brush.Style:=bsClear{bsSolid};
 Pen.Color := Self.Color;
 Brush.Color:=Self.Color;
 Pen.Width:=3;
 end;
 GradValues(TickCount);
 With Canvas Do
  begin
  iGrad:=Trunc(t1);
  EndA:=270-Trunc(p2 / 2);
  StartA:=270+Trunc(p2 / 2);
  An:=EndA;
  EndA:=EndA+360-(iGrad*(PositionOld div FSliding));
  midX:=Width div 2;
  midY:=Height div 2;
  Pen.Width:=3;
  MoveTo(midX,midY);
  ValuesTicks(EndA,Offset2);
  Pen.Color:=Self.Color;
  Brush.Color:=Self.Color;
  LineTo(CoordPointX,CoordPointY);

  Pen.Mode:=pmCopy;
  Pen.Color:=$00909090;
  Pen.Width:={2}1;
  ValuesTicks(An,Offset);
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(An,Offset2);
  LineTo(CoordPointX,CoordPointY);
  Pen.Color:=Self.Color;

  Pen.Mode:=pmCopy;
  Pen.Color:=clBlack;
  Brush.Color:=Self.Color;
  EndA:=270-Trunc(p2 / 2);
  EndA:=EndA+360-(iGrad*(PositionNatur div FSliding));
  midX:=Width div 2;
  midY:=Height div 2;
  Pen.Width:=3;
  MoveTo(midX,midY);
  ValuesTicks(EndA,Offset2);
  LineTo(CoordPointX,CoordPointY);

  If not PrintValues Then
   begin
   Brush.Color:=Self.Color;
   Brush.Style:=bsSolid;
   tW:=TextWidth(Format('%d',[FPosition*FSliding]));
   tH:=TextHeight(Format('%d',[FPosition*FSliding]));
   Pen.Color:=clBlack;
   TextOut(midX-5,Height-30,Format('%d',[FPosition*FSliding]));
   end;
  DrawTicks;
  end;
end;

Procedure TASMetr.Paint;
begin
 If FMax=0
  Then TickCount:=FMax+1
  Else TickCount:=FMax;
 Height:=Width;
 midX:=Width div 2;
 midY:=Height div 2;
 With Canvas Do
  begin
  Brush.Style:=bsClear;
  Brush.Color:=Self.Color;
  FillRect(ClientRect);
  Dest:=Rect(0,0,Width,Height);
  DrawFace;
  DrawTicks;
  DrawPointer;
  Pen.Color:=clSilver;
  Brush.Style:=bsClear;

  Brush.Color:=clGreen;
  Ellipse(midX-8,midY-8,midX+8,
          midY+8);
          
{  Pen.Width:=3;
  MoveTo(CoordPointX,CoordPointY);
  ValuesTicks(234,Offset+18);
  Pen.Color:=$00909090;
  LineTo(CoordPointX,CoordPointY);}
  end;
end;

Procedure TASMetr.SetPosition(Value:Integer);
begin
If Value <> FPosition Then
 begin
 If Value >FMax Then Value:=FMax;
 If Value <0 Then Value:=0;
 PositionOld:=PositionNatur;
 PositionNatur:=Value*FSliding;
 FPosition:=Value;
 If csDesigning in ComponentState
  Then Invalidate
  Else
   begin
   If FMax=0
    Then TickCount:=FMax+1
    Else TickCount:=FMax;

   With Canvas Do
    begin
    DrawPointer;
    Pen.Color:=clSilver;
    Brush.Style:=bsClear;

    Brush.Color:=clGreen;
    Ellipse(midX-8,midY-8,midX+8,
            midY+8);
    end;
   end;
 end;
end;

Procedure TASMetr.SetMax(Value:Integer);
begin
If Value <> FMax Then
 begin
 If (Value >= 0)and(Value <= 270) Then FMax:=Value;
 If FMax=0
  Then TickCount:=FMax+1
  Else TickCount:=FMax;
 DrawPointer;
 Invalidate;
 Width:=Width+1;
 Width:=Width-1;
 end;
end;

Procedure TASMetr.SetSliding(Value:Integer);
begin
If Value <> FSliding
 Then
  begin
  If Value<=0 Then Value:=1;
  FSliding:=Value;
  Invalidate;
  end;
end;

Procedure TASMetr.SetPrintValues(Value:Boolean);
begin
If Value <> FPrintValues
 Then
  begin
  FPrintValues:=Value;
  Invalidate;
  end;
end;

procedure Register;
begin
  RegisterComponents('AbakSoft', [TASMetr]);
end;

end.
